Index: issm/trunk/src/c/shared/Alloc/xNewDelete.h
===================================================================
--- issm/trunk/src/c/shared/Alloc/xNewDelete.h	(revision 13405)
+++ issm/trunk/src/c/shared/Alloc/xNewDelete.h	(revision 13975)
@@ -8,10 +8,9 @@
 #include <cassert>
 
-
 // memory management of types 
 // T with non-trivial constructors require 
 // C++ style memory management
 #define USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
-// but for speed on may alternatively use C memory managment
+// but for speed on may alternatively use C memory management
 // but can do so safely only for T that are at most 
 // plain old data structures (POD)
@@ -69,4 +68,24 @@
   assert(aT_p);
   return aT_p;
+#endif
+}
+
+template <class T>
+T** xNewZeroInit(unsigned int dim1, unsigned int dim2) {
+#ifdef USE_CXX_MEMORY_MANAGMENT_FOR_NON_POD_TYPES
+  T** aT_pp=xNew<T>(dim1,dim2);
+  for (unsigned int i=0; i<dim1*dim2;++i)
+    (*aT_pp)[i]=(T)0;
+  return aT_pp;
+#else
+  T* buf=(T*)calloc(dim1*dim2*sizeof(T));
+  assert(buf );
+  T** aT_pp =(T**)malloc(dim1*sizeof(T*));
+  assert(aT_pp );
+  for (unsigned int i=0;i<dim1;++i) {
+    aT_pp [i]=buf;
+    buf+=dim2;
+  }
+  return aT_pp ;
 #endif
 }
@@ -134,3 +153,2 @@
 
 #endif
-
Index: issm/trunk/src/c/shared/Elements/Paterson.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/Paterson.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/Paterson.cpp	(revision 13975)
@@ -10,5 +10,5 @@
 
 IssmDouble Paterson(IssmDouble temperature){
-	
+
 	/*output: */
 	IssmDouble B;
@@ -29,5 +29,4 @@
 //	% fittedmodel=fit(Temp,B,'cubicspline');
 //	% B=fittedmodel(temperature);
-
 
 	if(T<=-45.0){
@@ -61,5 +60,5 @@
 		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.003748937622487*pow(T+5,3)+0.015290593619213*pow(T+5,2)  -0.048160403003748*(T+5)+  0.854987973338348);
 	}
-	else if(T>=-2.0){
+	else{
 		B=pow((IssmPDouble)10,(IssmPDouble)8)*(-0.003748937622488*pow(T+2,3)-0.018449844983174*pow(T+2,2)  -0.057638157095631*(T+2)+  0.746900791092860);
 	}
@@ -70,5 +69,2 @@
 	return B;
 }
-
-
-
Index: issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/PddSurfaceMassBalance.cpp	(revision 13975)
@@ -10,6 +10,6 @@
   IssmDouble B;    // surface mass balance, melt+accumulation
 
-  int    iqj,imonth, j;
-  
+  int    iqj,imonth;
+
   IssmDouble saccu;     // yearly surface accumulation
   IssmDouble smelt;     // yearly melt
@@ -19,6 +19,5 @@
   IssmDouble runoff; //meltwater only, does not include rain 
   IssmDouble sconv; //rhow_rain/rhoi / 12 months
-  
-  IssmDouble density;
+
   IssmDouble lapser=6.5/1000., sealev=0.;    // lapse rate. degrees per meter. 7.5 lev's 99 paper, 9 Marshall 99 paper
   IssmDouble desfac = 0.5;                 // desert elevation factor
@@ -27,5 +26,5 @@
   IssmDouble st;             // elevation between altitude of the temp record and current altitude
   IssmDouble sp;             // elevation between altitude of the prec record and current altitude
-  
+
   // PDD and PD constants and variables
   IssmDouble siglim;          // sigma limit for the integration which is equal to 2.5 sigmanorm
@@ -35,5 +34,5 @@
   IssmDouble DT = 0.02;
   IssmDouble pddt, pd; // pd: snow/precip fraction, precipitation falling as snow
-  
+
   IssmDouble q, qmpt; // q is desert/elev. fact, hnpfac is huybrect fact, and pd is normal dist.
   IssmDouble qm = 0.;        // snow part of the precipitation 
@@ -42,22 +41,21 @@
   IssmDouble pdd = 0.;     
   IssmDouble frzndd = 0.;  
-  
+
   IssmDouble tstar;          // monthly mean surface temp
   IssmDouble Tsum= 0.;       // average summer (JJA) temperature
   IssmDouble Tsurf = 0.;     // average annual temperature    
-  
 
   IssmDouble deltm=1./12.;
   int    ismon[12]={11,0,1,2,3,4,5,6,7,8,9,10};
-  
+
   IssmDouble snwm;  // snow that could have been melted in a year.
   IssmDouble snwmf; //  ablation factor for snow per positive degree day.
   IssmDouble smf;   //  ablation factor for ice per pdd (Braithwaite 1995 from tarasov 2002).
-  
+
   IssmDouble dfrz=1.5, CovrLm=2009./3.35e+5, dCovrLm=dfrz*CovrLm; //m*J kg^-1 C^-1 /(J kg^-1)=m/C yr
   IssmDouble supice,supcap,diffndd;
   IssmDouble fsupT=0.5,  fsupndd=0.5;  // Tsurf mode factors for supice
   IssmDouble pddtj, hmx2;
-  
+
   sconv=(rho_water/rho_ice)/12.; //rhow_rain/rhoi / 12 months
 
@@ -68,13 +66,13 @@
   siglim0c = siglimc/DT + 0.5;
   PDup = siglimc+PDCUT;
-  
+
   // seasonal loop
     for (iqj = 0; iqj < 12; iqj++){
       imonth =  ismon[iqj];
-  
+
       st=(s-s0t)/1000.;
       tstar = monthlytemperatures[imonth] - lapser *max(st,sealev);
       Tsurf = tstar*deltm+Tsurf;        
-      
+
       /*********compute PD ****************/
       if (tstar < PDup){
@@ -83,15 +81,15 @@
       else { 
 	pd = 0.;}
-      
+
       /******exp des/elev precip reduction*******/
       sp=(s-s0p)/1000.; // deselev effect is wrt chng in topo
       if (sp>0.0){q = exp(-desfac*sp);}
       else {q = 1.0;}
-      
+
       qmt= qmt + monthlyprec[imonth]*sconv;  //*sconv to convert in m of ice equivalent per month
       qmpt= q*monthlyprec[imonth]*sconv;           
       qmp= qmp + qmpt;
       qm= qm + qmpt*pd;
-      
+
       /*********compute PDD************/
       // ndd(month)=-(tstar-pdd(month)) since ndd+pdd gives expectation of
@@ -105,10 +103,10 @@
       else{frzndd = frzndd - tstar*deltm; }
   } // end of seasonal loop 
-  
+
   //******************************************************************
     saccu = qm;
     prect = qmp;     // total precipitation during 1 year taking into account des. ef.
     Tsum=Tsum/3;
-    
+
     /***** determine PDD factors *****/
     if(Tsum< -1.) {
@@ -126,10 +124,10 @@
     snwmf=0.95*snwmf;
     smf=0.95*smf;
-    
+
     /*****  compute PDD ablation and refreezing *****/
     pddt = pdd *365;
     snwm = snwmf*pddt;       // snow that could have been melted in a year
     hmx2 = min(h,dfrz);   // refreeze active layer max depth: dfrz
-    
+
     if(snwm < saccu) {
       water=prect-saccu + snwm; //water=rain + snowmelt
@@ -147,7 +145,7 @@
       //     hold the meltwater around for refreezing? And melt-time will have
       //     low seasonal frzndd
-      
+
       //      Superimposed ice :  Pfeffer et al. 1991, Tarasov 2002
-      
+
       supice= min(hmx2*CovrLm*frzndd+2.2*(saccu-snwm), water); // superimposed ice
       supcap=min(2.2*(saccu-snwm),water);
@@ -172,5 +170,5 @@
     //     does supice make sense when H< 0.1m? then d=thermoactive ice layer ////
     //     < 0.1 
-    
+
     //     make more sense to just use residual pdd-ndd except that pdd
     //     residual not clear yet
@@ -197,9 +195,9 @@
     if(Tsurf<0) {
       Tsurf= min(Tsurf+fsupT*diffndd , 0.);}
-    
+
     B = -smelt+saccu;
     B = B/yts;
     pddtj=pddt;
-  
+
   return B;
 }
Index: issm/trunk/src/c/shared/Elements/PrintArrays.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 13975)
@@ -10,4 +10,21 @@
 		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
 		_printLine_(" ]");
+	}  
+	_printLine_("");
+}
+void printsparsity(IssmPDouble* array,int lines,int cols){
+	int count;
+	_printLine_("");
+	for(int i=0;i<lines;i++){  
+		_printString_("   [ ");
+		count = 0;
+		for(int j=0;j<cols;j++){
+			if(array[i*cols+j]!=0.0){
+				_printString_( " X"); count++;
+			}
+			else
+			 _printString_( " .");
+		}
+		_printLine_(" ] "<<i<<" => "<<count);
 	}  
 	_printLine_("");
Index: issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 13975)
@@ -20,5 +20,5 @@
 void TransformLoadVectorCoord(ElementVector* pe,Node** nodes,int numnodes,int* cs_array){
 
-	int     i,j;
+	int     i;
 	int     numdofs   = 0;
 	IssmDouble *transform = NULL;
Index: issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 13975)
@@ -21,5 +21,5 @@
 void TransformSolutionCoord(IssmDouble* solution,Node** nodes,int numnodes,int* cs_array){
 
-	int     i,j;
+	int     i;
 	int     numdofs   = 0;
 	IssmDouble *transform = NULL;
Index: issm/trunk/src/c/shared/Elements/elements.h
===================================================================
--- issm/trunk/src/c/shared/Elements/elements.h	(revision 13405)
+++ issm/trunk/src/c/shared/Elements/elements.h	(revision 13975)
@@ -40,4 +40,5 @@
 void printarray(IssmPDouble* array,int lines,int cols=1);
 void printarray(int* array,int lines,int cols=1);
+void printsparsity(IssmPDouble* array,int lines,int cols=1);
 void printbinary(int n);
 #endif //ifndef _SHARED_ELEMENTS_H_
Index: issm/trunk/src/c/shared/Exceptions/Exceptions.cpp
===================================================================
--- issm/trunk/src/c/shared/Exceptions/Exceptions.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Exceptions/Exceptions.cpp	(revision 13975)
@@ -12,5 +12,5 @@
 #include "../../include/include.h"
 
-ErrorException::ErrorException(const string &what_arg){
+ErrorException::ErrorException(const string &what_arg){/*{{{*/
 
 	what_str=what_arg;
@@ -18,7 +18,6 @@
 	function_name="";
 	file_line=0;
-}
-
-ErrorException::ErrorException(const string& what_file, const string& what_function,int what_line, const string& what_arg){
+}/*}}}*/
+ErrorException::ErrorException(const string& what_file, const string& what_function,int what_line, const string& what_arg){/*{{{*/
 
 	what_str=what_arg;
@@ -26,20 +25,18 @@
 	function_name=what_function;
 	file_line=what_line;
-}
+}/*}}}*/
+ErrorException::~ErrorException() throw(){/*{{{*/
+}/*}}}*/
+const char* ErrorException::what() const throw(){/*{{{*/
+	return what_str.c_str();
+}/*}}}*/
+void ErrorException::Report() const{/*{{{*/
 
-ErrorException::~ErrorException() throw(){
-	extern int num_procs;
-	/*We want the report only for matlab modules, otherwise we get twice the report
-	 * We assume that if num_procs==1, it is a module (FIXME)*/
-	if(num_procs==1) this->Report();
-}
+	int my_rank;
+	int num_procs;
 
-const char* ErrorException::what() const throw(){
-	return what_str.c_str();
-}
-
-void ErrorException::Report() const{
-	extern int my_rank;
-	extern int num_procs;
+	/*recover my_rank and num_procs:*/
+	my_rank=IssmComm::GetRank();
+	num_procs=IssmComm::GetSize();
 
 	if (function_name=="" || file_line==0){ //WINDOWS
@@ -48,12 +45,44 @@
 	else{
 		if(num_procs==1){
-			_printLine_("\n??? Error using ==> " << file_name.c_str() << ":" << file_line);
+			_printLine_("\n??? Error in ==> " << file_name.c_str() << ":" << file_line);
 			_printLine_(function_name.c_str() << " error message: " << what() << "\n");
 		}
 		else{
-			_printLine_("\n[" << my_rank << "] ??? Error using ==> " << file_name.c_str() << ":" << file_line);
-			_printLine_("[" << my_rank << "] " << function_name.c_str() << " error message: " << what() << "\n");
+			_printLine_("\n[" << my_rank<< "] ??? Error using ==> " << file_name.c_str() << ":" << file_line);
+			_printLine_(  "[" << my_rank << "] " << function_name.c_str() << " error message: " << what() << "\n");
 		}
 	}
 	return;
-}
+}/*}}}*/
+const char* ErrorException::MatlabReport() const{/*{{{*/
+
+	/*Output*/
+	std::ostringstream buffer;
+
+	if (this->file_line==0){ //WINDOWS
+		 buffer << " error message: " << (this->what_str).c_str();
+	}
+	else{
+		buffer << "\nError in ==> " << (this->file_name).c_str() << ":" << file_line << "\n";
+		buffer << (this->function_name).c_str() << " error message: " << (this->what_str).c_str();
+	}
+
+	const string buffer2 = buffer.str();
+	return buffer2.c_str();
+}/*}}}*/
+const char* ErrorException::PythonReport() const{/*{{{*/
+
+	/*Output*/
+	std::ostringstream buffer;
+
+	if (this->file_line==0){ //WINDOWS
+		buffer << " error message: " << (this->what_str).c_str();
+	}
+	else{
+		buffer << "\nError in ==> " << (this->file_name).c_str() << ":" << file_line << "\n";
+		buffer << (this->function_name).c_str() << " error message: " << (this->what_str).c_str();
+	}
+
+	const string buffer2 = buffer.str();
+	return buffer2.c_str();
+}/*}}}*/
Index: issm/trunk/src/c/shared/Exceptions/exceptions.h
===================================================================
--- issm/trunk/src/c/shared/Exceptions/exceptions.h	(revision 13405)
+++ issm/trunk/src/c/shared/Exceptions/exceptions.h	(revision 13975)
@@ -16,5 +16,5 @@
 /*We derive our classes from the c++ exception class: */
 class ErrorException: public exception {
-	
+
 	string   what_str;
 	string   function_name;
@@ -28,4 +28,6 @@
 	virtual const char *what() const throw();
 	void Report() const;
+	const char* MatlabReport() const;
+	const char* PythonReport() const;
 
 };
Index: issm/trunk/src/c/shared/Exceptions/exprintf.cpp
===================================================================
--- issm/trunk/src/c/shared/Exceptions/exprintf.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Exceptions/exprintf.cpp	(revision 13975)
@@ -5,5 +5,4 @@
  * ErrorException(exprintf("%s%i\n","test failed for id:",id));
  */ 
-
 
 #include <stdarg.h>
@@ -17,5 +16,4 @@
 	char *buffer = NULL;
 	int   n,size = 100;
-	int   string_size;
 
 	//variable list of arguments
Index: issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp
===================================================================
--- issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp	(revision 13975)
@@ -5,15 +5,12 @@
 #include <math.h>
 
-
 #include "./exp.h"
-
 
 int IsInPolySerial(double* in,double* xc,double* yc,int numvertices,double* x,double* y,int nods, int edgevalue){
 
-	int i,j;
 	double x0,y0;
 
 	/*Go through all vertices of the mesh:*/
-	for (i=0;i<nods;i++){
+	for(int i=0;i<nods;i++){
 		if (in[i]){
 			/*this vertex already is inside one of the contours, continue*/
Index: issm/trunk/src/c/shared/Exp/exp.h
===================================================================
--- issm/trunk/src/c/shared/Exp/exp.h	(revision 13405)
+++ issm/trunk/src/c/shared/Exp/exp.h	(revision 13975)
@@ -60,5 +60,5 @@
 template <class doubletype>
 int DomainOutlineRead(int* pnprof,int** pprofnvertices,doubletype*** ppprofx,doubletype*** ppprofy,bool** pclosed,char* domainname){
-	
+
 	/*indexing: */
 	int i,counter;
@@ -90,9 +90,9 @@
 	nprof=1;
 	for(;;){
-		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
-		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
-		fscanf(fid,"%256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy);
-		fscanf(fid,"%20u %256s\n",&n,chardummy);
-		fscanf(fid,"%256s %256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
+		fscanf(fid,"%255s %255s\n",chardummy,chardummy);
+		fscanf(fid,"%255s %255s\n",chardummy,chardummy);
+		fscanf(fid,"%255s %255s %255s %255s\n",chardummy,chardummy,chardummy,chardummy);
+		fscanf(fid,"%20u %255s\n",&n,chardummy);
+		fscanf(fid,"%255s %255s %255s %255s %255s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
 		for (i=0;i<n;i++) fscanf(fid,"%20lf %20lf\n",&ddummy,&ddummy);
 		/*check whether we are at the end of the file, otherwise, keep reading next profile:*/
@@ -100,5 +100,5 @@
 		nprof++;
 	}
-	
+
 	/*Allocate and initialize all the profiles: */
 	profnvertices = xNew<int>(nprof);
@@ -118,18 +118,18 @@
 
 		/*Skip header: */
-		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
-		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
-		fscanf(fid,"%256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy);
-		
+		fscanf(fid,"%255s %255s\n",chardummy,chardummy);
+		fscanf(fid,"%255s %255s\n",chardummy,chardummy);
+		fscanf(fid,"%255s %255s %255s %255s\n",chardummy,chardummy,chardummy,chardummy);
+
 		/*Get number of profile vertices: */
-		fscanf(fid,"%20u %256s\n",&n,chardummy);
-	
+		fscanf(fid,"%20u %255s\n",&n,chardummy);
+
 		/*Skip next line: */
-		fscanf(fid,"%256s %256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
+		fscanf(fid,"%255s %255s %255s %255s %255s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
 
 		/*Allocate vertices: */
 		x=xNew<doubletype>(n);
 		y=xNew<doubletype>(n);
-		
+
 		/*Read vertices: */
 		for (i=0;i<n;i++){
@@ -170,5 +170,4 @@
 	doubletype         **pprofx        = NULL;
 	doubletype         **pprofy        = NULL;
-	Contour<doubletype> *contour       = NULL;
 
 	/*output: */
Index: issm/trunk/src/c/shared/Numerics/UnitConversion.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/UnitConversion.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/UnitConversion.cpp	(revision 13975)
@@ -40,9 +40,8 @@
 }
 
-
 IssmDouble UnitConversionScaleFactor(int type_enum){
 
 	IssmDouble yts=365.0*24.0*3600.0;
-	
+
 	IssmDouble scale;
 	switch(type_enum){
@@ -72,4 +71,5 @@
 		case SurfaceforcingsANegEnum:						scale=yts;break;     //m/yr
 		case SurfaceforcingsBNegEnum:						scale=yts;break;     //m/yr
+		case SurfaceforcingsSmbrefEnum:					scale=yts;break;     //m/yr
 		case MisfitEnum:                             scale=pow(yts,2);break; //(m/yr)^2
 		case MassFluxEnum:                           scale=pow((IssmDouble)10,-12)*yts;break; // (GigaTon/year)
Index: issm/trunk/src/c/shared/Numerics/Verbosity.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/Verbosity.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/Verbosity.cpp	(revision 13975)
@@ -28,4 +28,5 @@
 bool VerboseControl(void){return (GetVerbosityLevel() & 32);} /* 2^5*/
 bool VerboseQmu(void){return (GetVerbosityLevel() & 64);} /* 2^6*/
+bool VerboseAutodiff(void){return (GetVerbosityLevel() & 128);} /* 2^7*/
 
 /*Verbosity Setup*/
@@ -41,7 +42,5 @@
 /*FUNCTION GetVerbosityLevel {{{*/
 int  GetVerbosityLevel(void){
-
 	_assert_(verbositylevel>=0);
 	return verbositylevel;
-
 }/*}}}*/
Index: issm/trunk/src/c/shared/Numerics/Verbosity.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/Verbosity.h	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/Verbosity.h	(revision 13975)
@@ -14,4 +14,5 @@
 bool VerboseControl(void);
 bool VerboseQmu(void);
+bool VerboseAutodiff(void);
 
 /*Setup Verbosity level*/
Index: issm/trunk/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/XZvectorsToCoordinateSystem.cpp	(revision 13975)
@@ -7,9 +7,8 @@
 void XZvectorsToCoordinateSystem(IssmDouble* T,IssmDouble* xzvectors){
 
-	int		i,j;
 	IssmDouble	x[3],y[3],z[3];
 	IssmDouble	x_norm, y_norm, z_norm;
 
-	for(i=0;i<6;i++){
+	for(int i=0;i<6;i++){
 		if(xIsNan<IssmDouble>(xzvectors[i])){
 			/*At least one NaN found: default to Id*/
Index: issm/trunk/src/c/shared/Numerics/isnan.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/isnan.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/isnan.cpp	(revision 13975)
@@ -1,9 +1,15 @@
 /*This routine only used by Intel compler: */
+
+#ifdef HAVE_CONFIG_H
+   #include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
 
 #include "../../include/include.h"
 #include "isnan.h"
 
-#ifdef _HAVE_ADOLC_
-template <> int xIsNan<adouble> (const adouble& X) {
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
+template <> int xIsNan<adouble> (const adouble& X){
   return isnan(X.getValue());
 }
Index: issm/trunk/src/c/shared/Numerics/isnan.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/isnan.h	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/isnan.h	(revision 13975)
@@ -6,5 +6,12 @@
 #define _XISNAN_H_
 
-#include <cmath>
+#ifdef HAVE_CONFIG_H
+   #include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+/*If include cmath instead of math, isnan on linux64 murdo does not work: */
+#include <math.h>
 
 template <class T> int xIsNan(const T& X) {
@@ -16,5 +23,5 @@
 }
 
-#ifdef _HAVE_ADOLC_
+#if defined(_HAVE_ADOLC_) && !defined(_WRAPPERS_)
 template <> int xIsNan<adouble> (const adouble& X);
 #endif
Index: issm/trunk/src/c/shared/Numerics/recast.h
===================================================================
--- issm/trunk/src/c/shared/Numerics/recast.h	(revision 13405)
+++ issm/trunk/src/c/shared/Numerics/recast.h	(revision 13975)
@@ -9,5 +9,11 @@
 #define _RECAST_H_
 
-#ifndef _HAVE_ADOLC_
+#ifdef HAVE_CONFIG_H
+   #include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#if !defined(_HAVE_ADOLC_) || defined(_WRAPPERS_)
 
 template<class To, class From>
Index: issm/trunk/src/c/shared/Sorting/binary_search.cpp
===================================================================
--- issm/trunk/src/c/shared/Sorting/binary_search.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/Sorting/binary_search.cpp	(revision 13975)
@@ -11,5 +11,5 @@
 #include <stdio.h>
 
-int binary_search(int* poffset,int target,int* sorted_integers,int num_integers){
+int binary_search(int* poffset,int target,int* sorted_integers,int num_integers){ /*{{{*/
 
 	/*output: */
@@ -18,7 +18,7 @@
 
 	/*intermediary: */
-	int* beg=NULL;
-	int* end=NULL;
-	int* mid=NULL;
+	int *beg = NULL;
+	int *end = NULL;
+	int *mid = NULL;
 
 	// point to beginning and end of the array
@@ -47,5 +47,5 @@
 			}
 		}
-			  
+
 		//did we find the target?
 		if (*mid == target) {
@@ -60,6 +60,6 @@
 	/*Assign output pointers:*/
 	*poffset=offset;
-	
+
 	/*Return result: */
 	return found;
-}
+} /*}}}*/
Index: issm/trunk/src/c/shared/Sorting/sorting.h
===================================================================
--- issm/trunk/src/c/shared/Sorting/sorting.h	(revision 13405)
+++ issm/trunk/src/c/shared/Sorting/sorting.h	(revision 13975)
@@ -7,4 +7,55 @@
 
 int binary_search(int* poffset,int target,int* sorted_integers,int num_integers);
+template <typename doubletype> int binary_search(int* poffset,doubletype target,doubletype* list,int length){ /*{{{*/
+	/*
+	 *             l[0]  l[1]  l[2]        l[n]  l[n+1]   l[length-1]
+	 *     <-------+-----+-----+-----+ ... +-----+........+-------------->
+	 * offset: -1     0     1     2           n              length -1
+	 *  
+	 *  offset = -1        target < list[0]
+	 *  offset = n         list[n] <= target < list[n+1]
+	 *  offset = length-1  list[length-1] <= target
+	 */
+
+	/*output: */
+	int offset = 0;
+	int found  = 0;
+
+	/*intermediary: */
+	int n0 = 0;
+	int n1 = int(length/2);
+	int n2 = length-1;
+
+	if(target<list[n0]){
+		found  = 1;
+		offset = -1;
+	}
+	else if(target>=list[n2]){
+		found  = 1;
+		offset = length-1;
+	}
+	else{
+		for(;;){
+			/*did we find the target?*/
+			if(list[n1]<=target && list[n1+1]>target){
+				found  = 1;
+				offset = n1;
+				break;
+			}
+			else if(target < list[n1]){
+				n2 = n1;
+				n1 = n0 + int((n2-n0)/2);
+			}
+			else{
+				n0 = n1;
+				n1 = n0 + int((n2-n0)/2);
+			}
+		}
+	}
+
+	/*Assign output pointer and return*/
+	*poffset=offset;
+	return found;
+} /*}}}*/
 
 #endif //ifndef _SORTING_H_
Index: issm/trunk/src/c/shared/String/sharedstring.h
===================================================================
--- issm/trunk/src/c/shared/String/sharedstring.h	(revision 13405)
+++ issm/trunk/src/c/shared/String/sharedstring.h	(revision 13975)
@@ -8,4 +8,7 @@
 int  DescriptorIndex(char* root, int* pindex,char* descriptor);
 
+#ifndef WIN32
+int stricmp(const char* a,const char* b);
+#endif
+
 #endif //ifndef _SHAREDSTRING_H_
-
Index: issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp
===================================================================
--- issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 13405)
+++ issm/trunk/src/c/shared/TriMesh/TriMeshUtils.cpp	(revision 13975)
@@ -17,5 +17,5 @@
 	/*Does this node belong to 4 elements, or just 2? If it belongs to 4 elements, it is inside a rift, 
 	 *if it belongs to 2 elements, it is on the tip of a rift, or it has already been split across the rift (see below).*/
-	
+
 	int i;
 	int j;
@@ -119,8 +119,8 @@
 /*FUNCTION RiftSegmentsFromSegments{{{*/
 void RiftSegmentsFromSegments(int* pnriftsegs, int** priftsegments, int nel, double* index, int nsegs,double* segments){
-	
+
 	int i,counter;
 	int el,el2;
-	
+
 	int  nriftsegs;
 	int* riftsegments=NULL;
@@ -179,5 +179,5 @@
 
 	xDelete<int>(riftsegments_uncompressed);
-	
+
 	/*Assign output pointers: */
 	*priftsegments=riftsegments;
@@ -266,5 +266,5 @@
 	/*Reallocate segments: */
 	segments         =xReNew<double>(segments,         nsegs*3,(nsegs+nriftsegs)*3);
-	segmentmarkerlist=xReNew<double>(segmentmarkerlist,nsegs*3,(nsegs+nriftsegs)*3);
+	segmentmarkerlist=xReNew<double>(segmentmarkerlist,nsegs,(nsegs+nriftsegs));
 
 	/*First, update the existing segments to the new nodes :*/
@@ -344,17 +344,6 @@
 	*psegmentmarkerlist=segmentmarkerlist;
 	*pnsegs=nsegs;
-	
+
 	return noerr;
-}/*}}}*/
-/*FUNCTION pnpoly{{{*/
-int pnpoly(int npol, double *xp, double *yp, double x, double y) {
-	int i, j, c = 0;
-	for (i = 0, j = npol-1; i < npol; j = i++) {
-		if ((((yp[i]<=y) && (y<yp[j])) ||
-					((yp[j]<=y) && (y<yp[i]))) &&
-				(x < (xp[j] - xp[i]) * (y - yp[i]) / (yp[j] - yp[i]) + xp[i]))
-			c = !c;
-	}
-	return c;
 }/*}}}*/
 /*FUNCTION FindElement{{{*/
@@ -384,5 +373,5 @@
 	double *segmentmarkerlist = NULL;
 	int numsegs;
-	
+
 	/*output: */
 	int      new_numsegs;
@@ -460,5 +449,4 @@
 /*FUNCTION PairRiftElements{{{*/
 int PairRiftElements(int** priftsnumpairs, double*** priftspairs,int numrifts,int* riftsnumsegments, double** riftssegments,double* x,double* y){
-
 
 	int noerr=1;
@@ -693,5 +681,5 @@
 	int i;
 	int noerr=1;
-	
+
 	/*output: */
 	int riftflag=0;
@@ -717,5 +705,5 @@
 /*FUNCTION OrderRifts{{{*/
 int OrderRifts(double** priftstips, double** riftssegments,double** riftspairs,int numrifts,int* riftsnumsegments,double* x,double* y,int nods,int nels){
-	
+
 	int noerr=1;
 	int i,j,k,counter;
@@ -747,5 +735,5 @@
 		riftpairs=riftspairs[i];
 		numsegs=riftsnumsegments[i];
-	
+
 		/*Allocate copy of riftsegments and riftpairs, 
 		 *as well as ordering vector: */
@@ -793,5 +781,5 @@
 				}
 			}
-		
+
 			if (node4==node2){
 				/*node2 is a tip*/
@@ -818,5 +806,5 @@
 				node1=(int)*(riftsegments+3*j+0);
 				node2=(int)*(riftsegments+3*j+1);
-				
+
 				if ((node1==node) || (node2==node)){
 					/*Ok, this segment is connected to node, plug its index into order, unless we already plugged it before: */
@@ -851,5 +839,5 @@
 			*(riftpairs_copy+2*j+1)=*(riftpairs+2*order[j]+1);
 		}
-		
+
 		for (j=0;j<numsegs;j++){
 			*(riftsegments+3*j+0)=*(riftsegments_copy+3*j+0);
@@ -873,5 +861,4 @@
 int PenaltyPairs(double*** priftspenaltypairs,int** priftsnumpenaltypairs,int numrifts,double** riftssegments,
 		int* riftsnumsegs,double** riftspairs,double* riftstips,double* x,double* y){
-		
 
 	int noerr=1;
@@ -906,5 +893,5 @@
 		/*allocate riftpenaltypairs, and riftnumpenaltypairs: */
 		if((numsegs/2-1)!=0)riftpenaltypairs=xNewZeroInit<double>((numsegs/2-1)*RIFTPENALTYPAIRSWIDTH);
-		
+
 		/*Go through only one flank of the rifts, not counting the tips: */
 		counter=0;
@@ -997,5 +984,5 @@
 			*(riftpenaltypairs+j*7+5)=*(riftpenaltypairs+j*7+5)/magnitude;
 		}
-		
+
 		riftspenaltypairs[i]=riftpenaltypairs;
 		riftsnumpenaltypairs[i]=(numsegs/2-1);
@@ -1035,5 +1022,4 @@
 	y=*py;
 	nods=*pnods;
-
 
 	for (i=0;i<num_seg;i++){
Index: issm/trunk/src/c/shared/TriMesh/trimesh.h
===================================================================
--- issm/trunk/src/c/shared/TriMesh/trimesh.h	(revision 13405)
+++ issm/trunk/src/c/shared/TriMesh/trimesh.h	(revision 13975)
@@ -22,5 +22,4 @@
 int DetermineGridElementListOnOneSideOfRift(int* pNumGridElementListOnOneSideOfRift, int** pGridElementListOnOneSideOfRift, int segmentnumber, int nriftsegs, int* riftsegments, int node,double* index,int nel);
 int UpdateSegments(double** psegments,double** psegmentmarkerlist, int* pnsegs, double* index, double* x,double* y,int* riftsegments,int nriftsegs,int nods,int nel);
-int pnpoly(int npol, double *xp, double *yp, double x, double y);
 int FindElement(double A,double B,double* index,int nel);
 int RemoveRifts(double** pindex,double** px,double** py,int* pnods,double** psegments,int* pnumsegs,int numrifts1,int* rifts1numsegs,double** rifts1segments,double** rifts1pairs,int nel);
Index: issm/trunk/src/c/shared/shared.h
===================================================================
--- issm/trunk/src/c/shared/shared.h	(revision 13405)
+++ issm/trunk/src/c/shared/shared.h	(revision 13975)
@@ -6,18 +6,17 @@
 #define _SHARED_H_
 
-#include "Alloc/alloc.h"
-#include "Alloc/xNewDelete.h"
-#include "Bamg/shared.h"
-#include "Elements/elements.h"
-#include "Exceptions/exceptions.h"
-#include "Exp/exp.h"
-#include "Matrix/matrix.h"
-#include "MemOps/xMemCpy.h"
-#include "Numerics/numerics.h"
-#include "Sorting/sorting.h"
-#include "Sys/sys.h"
-#include "Threads/issm_threads.h"
-#include "TriMesh/trimesh.h"
-#include "Wrapper/wrappershared.h"
+#include "./Alloc/alloc.h"
+#include "./Alloc/xNewDelete.h"
+#include "./Bamg/shared.h"
+#include "./Elements/elements.h"
+#include "./Exceptions/exceptions.h"
+#include "./Exp/exp.h"
+#include "./Matrix/matrix.h"
+#include "./MemOps/xMemCpy.h"
+#include "./Numerics/numerics.h"
+#include "./Sorting/sorting.h"
+#include "./String/sharedstring.h"
+#include "./Threads/issm_threads.h"
+#include "./TriMesh/trimesh.h"
 
 #endif
Index: issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp
===================================================================
--- issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 13405)
+++ issm/trunk/src/c/solutions/AdjointCorePointerFromSolutionEnum.cpp	(revision 13975)
@@ -1,3 +1,3 @@
-/*!\file:  CorePointerFromSolutionEnum.cpp
+/*!\file:  AdjointCorePointerFromSolutionEnum.cpp
  * \brief: return type of analyses, number of analyses and core solution function.
  */ 
@@ -24,5 +24,5 @@
 
 	switch(solutiontype){
-	
+
 		case DiagnosticSolutionEnum:
 			adjointcore=&adjointdiagnostic_core;
@@ -38,5 +38,5 @@
 			break;
 	}
-	
+
 	/*Assign output pointer:*/
 	_assert_(padjointcore);
